##############################################################################
#
# Copyright (C) Zenoss, Inc. 2013-2016, all rights reserved.
#
# This content is made available according to terms specified in
# License.zenoss under the directory where your Zenoss product is installed.
#
##############################################################################

'''
AWS custom device loaders.
'''

from zope.interface import implements

from Products.Zuul import getFacade
from Products.ZenModel.interfaces import IDeviceLoader


class EC2AccountLoader(object):
    '''
    EC2 account loader.

    Used by including lines such as the following in a zenbatchload
    input file:

        /Devices/AWS/EC2 loader='ec2account', loader_arg_keys=['accountid', \
        'devicename', 'accesskey', 'secretkey', 'collector']
        my-aws-account-name accountid='<my-aws-account-id>', \
        devicename='<my-aws-device-name>', accesskey='<accesskey>', \
        secretkey='<secretkey>', collector='<collector>'
    '''

    implements(IDeviceLoader)

    def load_device(
            self, dmd, accountid, devicename, accesskey, secretkey,
            collector='localhost'):

        return getFacade('aws', dmd).add_ec2account(
            accountid, devicename, accesskey, secretkey, collector)
